        !Script intended to evaluate basins 
        !in the aimless shooting script

        program h
        implicit none
        
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        !                     Variables to change                 !
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        
        integer,parameter :: atom_sc = 9216
        integer,parameter :: molec_sc  = 512
        integer,parameter :: atom_per_molec = 18
        integer,parameter :: side1_molec = 8
        integer,parameter :: side2_molec = 8
        integer,parameter :: synthon_length = 8
        
        real,parameter :: a_basin_low = 1.51, a_basin_high = 1.80
        real,parameter :: b_basin_low = 0.80, b_basin_high = 1.40
        
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        
        integer :: a, b, c, d, i, j, k, m, n, p, q, r
        integer :: file_index, counter, gn
        integer :: fn
        integer :: size1, size2
        integer :: ha_f, ha_b, hb_f, hb_b
        
        integer :: incon, tp

        real :: a1, a2, a3, b1, b2, b3, c1, c2, c3, n1, n2, n3
        real,dimension(atom_sc) :: x,y,z
        
        character :: file_name*27, generic1*10
        character :: dir1*9 = "raw/crds/", buh*10
        
        !order parameter variables
        real,dimension(2) :: avg_b, avg_c, ratio_c2b
        
        real :: ratio(side1_molec*side2_molec)
        real :: dist_b(side1_molec*side2_molec)
        real :: dist_c(side1_molec*side2_molec)
        
        x(:) = 0.0
        y(:) = 0.0
        z(:) = 0.0
        
        do i = 1, 2
          if(i==1) file_name = "temp_output/x+.coor"
          if(i==2) file_name = "temp_output/x-.coor"
          open(i+100,file=file_name,status="old",action="read")
          read(i+100,*) buh
            
          !Read coordinates
          do k = 1, atom_sc
            read(i+100,*) buh,q,buh,buh,q,x(k), y(k), z(k)
          end do
          
          !b lattice vector calculation 1-181, 2-182,...
          !31-211, 32-212
          a = 1
          do m = 1, side1_molec
            do n = 1, side2_molec
              q = (m-1)*side1_molec + n
              p = q + side1_molec*side2_molec*synthon_length - 
     +          side1_molec*side2_molec
              q = (q-1)*atom_per_molec + 1
              p = (p-1)*atom_per_molec + 1
              dist_b(a) = (x(q)-x(p))**2 + (y(q)-y(p))**2 +
     +           (z(q)-z(p))**2
              dist_b(a) = sqrt(dist_b(a))
              a = a + 1
            end do 
          end do
          avg_b(i) = sum(dist_b(:))/real(side1_molec*side2_molec)

          !c lattice vector calculation 1-31, 2-32,...
          !37-67, 38-68, ...
          a = 1
          do m = 1, side1_molec
            do n = 1, side2_molec
              q = (m-1)*side1_molec*side2_molec + n
              p = q + side1_molec*side2_molec - side1_molec
              q = (q-1) * atom_per_molec + 1
              p = (p-1) * atom_per_molec + 1
              dist_c(a) = (x(q)-x(p))**2 + (y(q)-y(p))**2 +
     +          (z(q)-z(p))**2 
              dist_c(a) = sqrt(dist_c(a))
              a = a + 1
            end do
          end do
          avg_c(i) = sum(dist_c(:))/real(side1_molec*side2_molec)

          !ratio_c2b calculation
          a = 1
          do m = 1, side1_molec*side2_molec
            ratio(m) = dist_b(m)/dist_c(m)
          end do
          ratio_c2b(i) = sum(ratio(:))/real(side1_molec*
     +      side2_molec)
          
          !forward trajectory
          if(i==1) then
            if(ratio_c2b(i) > a_basin_low) then
              ha_f = 1
              hb_f = 0
            else if(ratio_c2b(i) < b_basin_high) then
              ha_f = 0
              hb_f = 1
            else
              ha_f = 0
              hb_f = 0
            end if
          end if
          
          !backwards trajectory
          if(i==2) then
            if(ratio_c2b(i) > a_basin_low) then
              ha_b = 1
              hb_b = 0
            else if(ratio_c2b(i) < b_basin_high) then
              ha_b = 0
              hb_b = 1
            else
              ha_b = 0
              hb_b = 0
            end if
          end if
        end do

 100    format(A12, T14, I1, T16, I1, T18, I1, T20, I1,
     +    T22, F7.4, T30, F7.4)
        open(unit=101,file="basin_evals.txt",action="write",
     +    position="append")
        open(unit=102,file="haf",action="write",status="replace")
        open(unit=103,file="hab",action="write",status="replace")
        open(unit=104,file="hbf",action="write",status="replace")
        open(unit=105,file="hbb",action="write",status="replace")
        incon = (ha_f + hb_f) * (ha_b + hb_b)
        if(incon == 0) then
          write(101,100) "Inconclusive", ha_f, hb_f, ha_b, hb_b,
     +    ratio_c2b(1), ratio_c2b(2)
        else 
          if(incon == 2) then
            write(101,100) "Overlapping", ha_f, hb_f, ha_b, hb_b,
     +      ratio_c2b(1), ratio_c2b(2)
          else 
            if(incon == 1) then
              write(101,100) "Conclusive", ha_f, hb_f, ha_b, hb_b,
     +        ratio_c2b(1), ratio_c2b(2)
            end if 
          end if
        end if

        write(102,*) ha_f
        write(103,*) ha_b
        write(104,*) hb_f
        write(105,*) hb_b

        close(102)
        close(103)
        close(104)
        close(105)

        end program h
        
